package cn.sh.stc.sict.theme.hphy.controller.web;


import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.DesensitizedUtil;
import cn.hutool.core.util.StrUtil;
import cn.sh.stc.sict.cloud.common.core.constant.Constant;
import cn.sh.stc.sict.cloud.common.core.util.R;
import cn.sh.stc.sict.theme.hphy.model.HpAppointment;
import cn.sh.stc.sict.theme.hphy.service.HpAppointmentService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.api.ApiController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * [黄浦]预约记录(HpAppointment)维护接口
 *
 * @author makejava
 * @since 2021-01-28 10:35:57
 */
@Api(value = "[黄浦]预约记录维护接口", tags = "[黄浦]预约记录维护接口")
@RestController
@RequestMapping("hpAppointment")
@AllArgsConstructor
public class HpAppointmentController extends ApiController {
    /**
     * 服务对象
     */
    private final HpAppointmentService hpAppointmentService;


    @ApiOperation("分页查询 - 预约记录")
    @GetMapping("/app/page")
    public R appPage(Page<HpAppointment> page,
                     @RequestParam(value = "name", required = false) String name,
                     @RequestParam(value = "hospName", required = false) String hospName,
                     @RequestParam(value = "deptName", required = false) String deptName,
                     @RequestParam(value = "doctorName", required = false) String doctorName) {
        LambdaQueryWrapper<HpAppointment> wrapper = new LambdaQueryWrapper<>();
        wrapper.like(StrUtil.isNotBlank(name), HpAppointment::getPatientName, name)
                .like(StrUtil.isNotBlank(hospName), HpAppointment::getHosOrgName, hospName)
                .like(StrUtil.isNotBlank(doctorName), HpAppointment::getDoctorName, doctorName)
                .like(StrUtil.isNotBlank(deptName), HpAppointment::getDeptName, deptName)
                .orderByDesc(HpAppointment::getCreateTime);

        page = hpAppointmentService.page(page, wrapper);
        if(CollUtil.isNotEmpty(page.getRecords())){
            page.getRecords().forEach(i->{
                i.setPatientName(DesensitizedUtil.chineseName(i.getPatientName()));
                i.setUserPhone(DesensitizedUtil.mobilePhone(i.getUserPhone()));
            });
        }
        return new R(page);
    }

    @ApiOperation("分页查询 - 取消预约记录")
    @GetMapping("/cancel/page")
    public R cancelPage(Page page,
                        @RequestParam(value = "name", required = false) String name,
                        @RequestParam(value = "hospName", required = false) String hospName,
                        @RequestParam(value = "deptName", required = false) String deptName,
                        @RequestParam(value = "doctorName", required = false) String doctorName) {
        LambdaQueryWrapper<HpAppointment> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(HpAppointment::getStatus, Constant.BYTE_YES)
                .like(StrUtil.isNotBlank(name), HpAppointment::getPatientName, name)
                .like(StrUtil.isNotBlank(hospName), HpAppointment::getHosOrgName, hospName)
                .like(StrUtil.isNotBlank(doctorName), HpAppointment::getDoctorName, doctorName)
                .like(StrUtil.isNotBlank(deptName), HpAppointment::getDeptName, deptName)
                .orderByDesc(HpAppointment::getCreateTime);

        page = hpAppointmentService.page(page, wrapper);

        return new R(page);
    }
}